<template>
  <v-container fluid class="px-10">
    <v-row>
      <v-col cols="2">
        <v-btn small text to="/home">
          <v-icon small>mdi-arrow-left</v-icon>
          Back to Home
        </v-btn>
      </v-col>
    </v-row>
    <h1>Defect</h1>
    <v-divider class="mt-2 mb-4" />
    <v-row>
      <v-col>
        <h3>Defect History</h3>
      </v-col>
      <v-col cols="auto" class="d-flex align-center">
        <v-btn
          id="btn-add-size"
          color="primary"
          class="ml-5"
          dark
          @click="isModalVisible.createDefect = true"
          >Add Defect</v-btn
        >
      </v-col>
    </v-row>
    <v-divider class="mt-2" />
    <v-row>
      <v-col>
        <v-data-table :headers="defectHeaders" :items="Sizes" item-key="id">
        </v-data-table>
      </v-col>
    </v-row>
    <v-dialog v-model="isModalVisible.createDefect" max-width="600px">
      <v-card>
        <v-card-title>
          <span class="headline">Add Defect</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-form @submit.prevent="handleCreateDefect">
            <row dense>
              <v-row>
                  <v-col cols="6">
                    <v-select
                    v-model="defectForm.po"
                    item-text="name"
                    item-value="id"
                    :items="po"
                    label="PO"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
                <v-col cols="6">
                    <v-select
                    v-model="defectForm.reasonCategory"
                    item-text="name"
                    item-value="id"
                    :items="reasonCategory"
                    label="Reason Category"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
              </v-row>
              <v-row>
                  <v-col cols="6">
                    <v-select
                    v-model="defectForm.shift"
                    item-text="name"
                    item-value="id"
                    :items="shift"
                    label="Shift"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
                <v-col cols="6">
                    <v-select
                    v-model="defectForm.reason"
                    item-text="name"
                    item-value="id"
                    :items="reason"
                    label="Reason"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="6">
                    <v-text-field
                      id="total"
                      v-model="defectForm.total"
                      label="total"
                      type="number"
                      required
                      outlined
                      hide-details
                    />
                </v-col>
              </v-row>
            </row>
            </v-form>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="isModalVisible.createDefect = false">Cancel</v-btn>
          <v-btn id="btn-submit-size" color="primary" @click="handleCreateDefect">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
export default {
//   async asyncData({ store, $axios }) {
//     const { data: Defects } = await $axios.get('/api/v1/defects')

//     return {
//       Defects: Defects.data
//     }
//   },
  data: () => ({
    isModalVisible: {
      createDefect: false
    },
    defectHeaders: [
      { text: 'PO Number', value: 'poNumber' },
      { text: 'shift', value: 'shift' },
      { text: 'Reason', value: 'reason' },
      { text: 'Date & Time', value: 'dateTime' },
      { text: 'Total Defect', value: 'total' }
    ],
    defectForm: {
      po: '',
      reasonCategory: '',
      shift: '',
      reason: '',
      total: ''
    },
    selectedProduct: null
  }),
  methods: {
    formatDate(date) {
      return new Date(date).toLocaleString()
    },
    resetForm(form) {
      Object.keys(form).forEach((key) => (form[key] = ''))
    },
    handleCreateDefect() {
    //   this.$axios
    //     .post('/api/v1/defects', { ...this.defectForm })
    //     .then(() => {
    //       this.refreshList()
    //       this.isModalVisible.createDefect = false
    //     })
    //     .catch(({ response: { data } }) => {
    //       this.$toast.error(data.message)
    //     })
    },
    async refreshList() {
    //   const { data: Defects } = await this.$axios.get('/api/v1/defects')
    //   this.Defects = Defects.data
    }
  }
}
</script>
